from collections import deque, defaultdict

n, m, k = map(int, input().split())
graph = defaultdict(list)
for _ in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)
guards = []
for _ in range(k):
    p, h = map(int, input().split())
    guards.append((p, h))
protected = set()

for p, h in guards:
    visited = set()
    queue = deque([(p, 0)])

    while queue:
        current, dist = queue.popleft()

        if current in visited:
            continue
        visited.add(current)

        if dist > h:
            continue

        protected.add(current)

        for neighbor in graph[current]:
            if neighbor not in visited:
                queue.append((neighbor, dist + 1))
protected = sorted(protected)
print(len(protected))
print(" ".join(map(str, protected)))
